
if not gl.ARB_fragment_shader() or not gl.ARB_framebuffer_object() then
  local tex = CreateFrame("Text_Multiline")
  
  tex:SetText("This game requires some rather high-level graphics card capabilities. Unfortunately, your graphics card doesn't seem to be capable of them. You might be able to solve this by updating your drivers, but it's also possible that you simply don't have a graphics card that is able to do them.\n\nThis means you can't play the game. Sorry! I'd really love it if you could, but with a week to write an entire game, certain things (like compatibility) must be sacrificed. Come back next month for another game!\n\n(If you're curious, this game requires OpenGL ARB fragment shaders and OpenGL ARB framebuffer objects.)")
  tex:SetPoint("CENTER", UIParent, "CENTER")
  tex:SetWidth(600)
  tex:SetColor(1, 1, 1)
  tex:ForceHeight()

  return
end

local mode = ...
print(mode)

local blurry_shit
do
  local vertex = glutil.Shader("VERTEX", [[
    void main()
    {
      gl_Position = ftransform();
      gl_TexCoord[0]  = gl_MultiTexCoord0;
    }
  ]])
  local fragment = glutil.Shader("FRAGMENT", [[
    uniform sampler2D source;
    uniform vec2 offsets[5];
    
    void main()
    {
        vec4 c = vec4(0, 0, 0, 0);
        vec2 tc = gl_TexCoord[0].st;

        c += 0.0625 * texture2D(source, tc + offsets[0]);
        c += 0.25 * texture2D(source, tc + offsets[1]);
        c += 0.375 * texture2D(source, tc + offsets[2]);
        c += 0.25 * texture2D(source, tc + offsets[3]);
        c += 0.0625 * texture2D(source, tc + offsets[4]);

        gl_FragColor = c;
    }
  ]])
  blurry_shit = glutil.Program()
  glutil.AttachShader(blurry_shit, vertex)
  glutil.AttachShader(blurry_shit, fragment)
  glutil.LinkProgram(blurry_shit)
end

local norm_bright = 1.0
local bloom_bright = 1.0


local bloom_halt = CreateFrame("Frame")
bloom_halt:Hide()

local shmup = CreateFrame("Frame", bloom_halt)
shmup:SetPoint("TOPLEFT", UIParent, "TOPLEFT")
shmup:SetHeight(UIParent:GetHeight())
shmup:SetWidth(math.floor(UIParent:GetHeight() / 1.3333333))
local sw, sh = shmup:GetWidth(), shmup:GetHeight()
local multisample_pass = 1
local multisample = math.pow(2, multisample_pass)
--sw, sh = 512, 512

local tutorial_text = CreateFrame("Text_Multiline")
tutorial_text:SetPoint("LEFT", UIParent, "LEFT", 600, nil)
tutorial_text:SetPoint("RIGHT", UIParent, "RIGHT", -20, nil)
tutorial_text:SetPoint("TOP", UIParent, "TOP", nil, 20)
tutorial_text:SetColor(1, 1, 1)
tutorial_text:Hide()

local tutorial_phase_current
local function tutorial_phase(phase)
  tutorial_phase_current = phase
  if phase == nil then
    tutorial_text:Hide()
  elseif phase == "basic" then
    tutorial_text:SetText("Use the arrow keys to move. Use Z to fire your gatling blaster. Don't get hit by enemies.")
    tutorial_text:ForceHeight()
    tutorial_text:Show()
  elseif phase == "grapple" then
    tutorial_text:SetText("Large enemies are immune to your blaster. Hit X to fire your grappler cannon. Time will slow down while you're grappling an enemy.")
    tutorial_text:ForceHeight()
    tutorial_text:Show()
  elseif phase == "postgrapple" then
    tutorial_text:SetText("Use the arrow keys and Z to make three-or-longer lines of same-colored nodes. Lines can be either horizontal or vertical. Hit X when you've made all the lines you feel capable of. Each line damages your opponent.\n\nBe careful - you can still be hurt while grappling an opponent!")
    tutorial_text:ForceHeight()
    tutorial_text:Show()
  else
    assert(false)
  end
end


local dels = {}
local function playsounddelay(sound, vol, delay)
  if not dels[sound] or dels[sound] <= 0 then
    PlaySound(sound, vol)
    dels[sound] = delay
  end
end


local ss_p_x, ss_p_y = 0, 0
local ss_d_x, ss_d_y = 0, 0
local pull = 0.3
local friction = 0.4
local function screenshake(magnitude)
  local ang = math.random() * 3.14159 * 2
  local x, y = math.sin(ang), math.cos(ang)
  ss_d_x, ss_d_y = ss_d_x + x * magnitude, ss_d_y + y * magnitude
end
local function screenshake_gx()
  return ss_p_x
end
local function screenshake_gy()
  return ss_p_y
end
local function screenshake_time(time)
  ss_p_x, ss_p_y = ss_p_x + ss_d_x * time, ss_p_y + ss_d_y * time
  ss_d_x, ss_d_y = (ss_d_x - ss_p_x * pull * time) * (1 - friction), (ss_d_y - ss_p_y * pull * time) * (1 - friction)
end

local cdist = 0

function shmup:DrawPre()
  --gl.Scissor(shmup:GetLeft(), shmup:GetTop(), sw, sh)
  --gl.Enable("SCISSOR_TEST")
  gl.MatrixMode("PROJECTION")
  --gl.PushMatrix()
  
  gl.Viewport(0, 0, sw * multisample, sh * multisample)

  local fov = 30
  local fovr = fov / 180 * 3.14159
  -- tan(fovr) == opposite / adjacent
  -- adjacent = opposite / tan(fovr)
  local dist = (sh / 2) / math.tan(fovr)
  gl.LoadIdentity()
  gluPerspective(fov * 2, sw / sh, 100, 10000)
  gl.Translate(0, 0, -dist)
  gl.Scale(1, -1, 1)
  gl.Translate(-sw / 2, -sh / 2, 0)
  cdist = dist
  
  gl.Enable("DEPTH_TEST")
  gl.DepthMask(true)
end
function shmup:DrawPost()
  --gl.Disable("SCISSOR_TEST")
  gl.MatrixMode("PROJECTION")
  
  gl.Disable("DEPTH_TEST")
  
  --gl.PopMatrix()
end

local ycenter_speed = 0
local ycenter = 0

local invincibility_end = 0
local respawn = nil
local player_death_count = 0

local bounds = CreateFrame("Frame", shmup)
bounds:SetAllPoints()
bounds:SetCoordinateScale(0, ycenter, sw)
local shaded = CreateFrame("RenderSorter", bounds)

local mega_shader
do
  local vertex = glutil.Shader("VERTEX", [[
    varying vec3 coords_int;
    attribute vec3 coords;
    
    varying vec3 delta_x;
    varying vec3 delta_y;
    
    attribute vec3 size;
    varying vec3 size_use;
    
    attribute float fadeable;
    varying float fadeable_use;
    
    void main()
    {
      gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
      
      delta_x = (gl_ModelViewProjectionMatrix * (gl_Vertex + vec4(1.0, 0.0, 0.0, 0.0)) - gl_Position).xyz;
      delta_y = (gl_ModelViewProjectionMatrix * (gl_Vertex + vec4(0.0, 1.0, 0.0, 0.0)) - gl_Position).xyz;
      
      coords_int = coords;
      
      size_use = size;
      fadeable_use = fadeable;
      
      gl_FrontColor = gl_Color;
      gl_BackColor = vec4(0.0);
    }
  ]])
  local fragment = glutil.Shader("FRAGMENT", [[
    varying vec3 coords_int;
    varying vec3 size_use;
    uniform float grid;
    uniform vec4 bgc;
    uniform vec3 grid_offset;
    
    varying vec3 delta_x;
    varying vec3 delta_y;
    
    uniform float fade;
    
    varying float fadeable_use;
    
    vec4 evaluate(vec3 coord) {
      vec3 pos = coord * size_use;
      vec3 ofspos = pos + vec3(grid, grid, grid) / 2.0 + grid_offset;
      vec3 deepness_grid = 1.0 - step(grid, fract(ofspos));
      vec3 deepness_edge_zero = 1.0 - step(0.2, pos);
      vec3 deepness_edge_pos = 1.0 - step(0.2, size_use - pos);
      
      vec3 deepness_dirs = max(max(deepness_grid, deepness_edge_zero), deepness_edge_pos);
      
      float deepness;
      if(deepness_dirs.x > deepness_dirs.y) {
        if(deepness_dirs.x > deepness_dirs.z) {
          // X > Y, X > Z
          deepness = max(deepness_dirs.y, deepness_dirs.z);
        } else {
          // X > Y, Z > X
          deepness = deepness_dirs.x;
        }
      } else {
        if(deepness_dirs.y > deepness_dirs.z) {
          // Y > X, Y > Z
          deepness = max(deepness_dirs.x, deepness_dirs.z);
        } else {
          // Y > X, Z > Y
          deepness = deepness_dirs.y;
        }
      }
      
      vec4 bgmod = bgc;
      bgmod.a = bgmod.a * gl_Color.a;
      
      return gl_Color * (deepness * 0.9 + 0.1) + bgmod;
    }
    
    void main()
    {
      vec4 accum = vec4(0.0, 0.0, 0.0, 0.0);
      
      /*
      accum = accum + evaluate(coords_int + delta_x * -0.15 + delta_y * -0.40);
      accum = accum + evaluate(coords_int + delta_x *  0.35 + delta_y * -0.15);
      accum = accum + evaluate(coords_int + delta_x *  0.10 + delta_y *  0.35);
      accum = accum + evaluate(coords_int + delta_x * -0.40 + delta_y *  0.10);
      
      accum = accum / 4.0;*/
      
      accum = evaluate(coords_int);
      
      if(fadeable_use > 0.5 && fade > 0.0) {
        float dens = (accum.r * 0.3 + accum.g * 0.59 + accum.b * 0.11) * fade / 2.0;
        
        accum.rgb = accum.rgb * (1.0 - fade) + vec3(dens, dens, dens);
      }
      
      gl_FragColor = accum;
      
      //gl_FragColor = gl_Color + accum / 1000.0;
    }
  ]])
  mega_shader = glutil.Program()
  glutil.AttachShader(mega_shader, vertex)
  glutil.AttachShader(mega_shader, fragment)
  glutil.LinkProgram(mega_shader)
  glutil.VertexAttribInit(mega_shader, "coords")
  glutil.VertexAttribInit(mega_shader, "fadeable")
  glutil.VertexAttribInit(mega_shader, "size")
end
shaded:SetShaderPriority(mega_shader, 0)



local subframe = 1
local overallframe = 0
local speed = 1
local speed_slomo = 0.3

local playerbullets = {}
local monsters = {}
local monsterbullets = {}
local tixers = {}
local dying = {}
local player

local ground_gen_class = 1
local ground_gen_class_cycles = 0
local function set_ground_class(gc)
  ground_gen_class = gc
  ground_gen_class_cycles = 0
end

local ground = CreateFrame("Frame", shaded)
ground:SetLayer(-1) -- doin' this until we get actual 3dality goin'


local function fadeamount()
  return 1 - (speed - speed_slomo) / (1 - speed_slomo)
end

do
  local wid = 850
  local gridx = 7
  local gridy = 10
  local hei = wid / gridx * gridy
  
  local unit = wid / gridx
  
  local sg, eg = 1/3, 2/3
  
  local tyles = {}
  local unitm = unit * math.sqrt(2)
  
  local function rendcube(cx, cy, cang, height)
    cang = cang + 3.14159 / 4
    local x = {}
    local y = {}
    for i = 1, 4 do
      table.insert(x, cx + unitm * math.sin(cang + 3.14159 / 2 * i))
      table.insert(y, cy + unitm * math.cos(cang + 3.14159 / 2 * i))
    end
    
    glutil.VertexAttrib(mega_shader, "coords", sg, sg, 0)
    gl.Vertex(x[1], y[1], -cdist + height)
    glutil.VertexAttrib(mega_shader, "coords", sg, eg, 0)
    gl.Vertex(x[2], y[2], -cdist + height)
    glutil.VertexAttrib(mega_shader, "coords", eg, eg, 0)
    gl.Vertex(x[3], y[3], -cdist + height)
    glutil.VertexAttrib(mega_shader, "coords", eg, sg, 0)
    gl.Vertex(x[4], y[4], -cdist + height)
    
    for a = 1, 4 do
      local b = rotate_mod(a + 1, 4)
      glutil.VertexAttrib(mega_shader, "coords", sg, sg, 0)
      gl.Vertex(x[a], y[a], -cdist + height)
      glutil.VertexAttrib(mega_shader, "coords", sg, eg, 0)
      gl.Vertex(x[b], y[b], -cdist + height)
      glutil.VertexAttrib(mega_shader, "coords", eg, eg, 0)
      gl.Vertex(x[b], y[b], -cdist + height - unit * 3)
      glutil.VertexAttrib(mega_shader, "coords", eg, sg, 0)
      gl.Vertex(x[a], y[a], -cdist + height - unit * 3)
    end
  end
  
  local function gen_another_row(ycoord)
    ground_gen_class_cycles = ground_gen_class_cycles + 1
    
    local mheight = 0
    if ground_gen_class == 2 then
      mheight = math.min(200, ground_gen_class_cycles * 10)
    end
    if ground_gen_class == 3 then
      mheight = 200
    end
    
    local heights = {}
    for i = 1, 7 do
      table.insert(heights, math.random() * mheight - mheight / 2)
    end
    
    local sy, ey = ycoord - hei / gridy, ycoord + hei / gridy
    
    local xrng = sw * 1.2
    
    local specs = {}
    
    local specct = 0
    if ground_gen_class == 3 then
      specct = math.min(ground_gen_class_cycles / 10, 4)
    end
    do
      local specfrac = specct - math.floor(specct)
      specct = math.floor(specct)
      if math.random() < specfrac then specct = specct + 1 end
    end
    for i = 1, specct do
      local specx = math.random() * xrng * 2 - xrng
      local specy = lerp(math.random(), sy, ey)
      local specz = math.random() * 200
      local specang = math.random() * 3.14159
      
      table.insert(specs, {x = specx, y = specy, z = specz, ang = specang})
    end
    
    return function ()
      for i = 1, 7 do
        rendcube((i - 0.5) * wid * 2 / gridx - wid, ycoord, 0, heights[i])
      end
      
      for _, v in pairs(specs) do
        rendcube(v.x, v.y, v.ang, v.z)
      end
    end
  end
  local old_y
  for gy = gridy, 1, -1 do
    local cy = (gy - 0.5) / gridy * hei * 2 - hei
    old_y = cy
    table.insert(tyles, gen_another_row(cy))
  end
  
  local old_ground
  local first = true
  
  function ground:Draw()

        
    local yc = math.floor(ycenter / (hei * 2 / gridy)) * (hei * 2 / gridy)
    if yc ~= old_ground then
      if not first then
        print("resynch at", old_y)
        table.remove(tyles, 1)
        old_y = old_y - hei * 2 / gridy
        table.insert(tyles, gen_another_row(old_y))
      end
      first = false
      old_ground = yc
    end
    
    RenderSort(mega_shader, function ()
      gl.Color(0.4, 0.1, 0.1)
      glutil.UniformF(mega_shader, "grid", 0.02)
      glutil.UniformF(mega_shader, "grid_offset", 0, 0, 0)
      glutil.UniformF(mega_shader, "bgc", 0.03, 0.03, 0.03, 1.0)
      glutil.UniformF(mega_shader, "fade", fadeamount())
      
      gl.Begin("QUADS")
      
      glutil.VertexAttrib(mega_shader, "size", 3, 3, 5)
      glutil.VertexAttrib(mega_shader, "fadeable", 1)
      
      for _, v in pairs(tyles) do
        v()
      end
      
      gl.End()
    end)
  end
end


local function CreateShifter(magnitude, frequency, loose)
  local rv = {}
  function rv:GenPoint(orig)
    if loose then
      return {orig[1] + math.random() * magnitude * 2 - magnitude, math.random() * frequency + frequency / 2}
    else
      return {math.random() * magnitude * 2 - magnitude, math.random() * frequency + frequency / 2}
    end
  end
  table.insert(rv, rv:GenPoint({0, 0}))
  table.insert(rv, rv:GenPoint(rv[1]))
  table.insert(rv, rv:GenPoint(rv[2]))
  table.insert(rv, rv:GenPoint(rv[3]))
  
  rv.cpos = rv[2][2] / 2
  
  function rv:Increment(frames)
    rv.cpos = rv.cpos + frames
    while rv.cpos > rv[2][2] do
      rv.cpos = rv.cpos - rv[2][2]
      table.remove(rv, 1)
      table.insert(rv, rv:GenPoint(rv[3]))
    end
    
    return cubic(rv[1][1], rv[2][1], rv[3][1], rv[4][1], rv.cpos / rv[2][2]) 
  end
  
  return rv
end


local function CreateShatterEffect(mon, tex, wid, dwid, ddwid, dx, dy, dz, r, g, b, lifemult)
  local efx = CreateFrame("Frame", bounds)
  efx:SetLayer(1000)
  local bright = 1
  local rx, ry, rz = math.random() * 360, math.random() * 360, math.random() * 360
  
  function efx:Render()
    gl.MatrixMode("MODELVIEW")
    gl.PushMatrix()
    gl.Translate(mon.x, mon.y, 0)
    gl.Rotate(rx, 1, 0, 0)
    gl.Rotate(ry, 0, 1, 0)
    gl.Rotate(rz, 0, 0, 1)
    
    gl.BlendFunc("SRC_ALPHA", "ONE_MINUS_SRC_ALPHA")
    gl.DepthMask(false)
    glutil.RenderCenteredSprite(Texture("slash"), 0, 0, wid, wid, r, g, b, bright)
    gl.DepthMask(true)
    gl.BlendFunc("SRC_ALPHA", "ONE_MINUS_SRC_ALPHA")
    
    gl.PopMatrix()
  end
  local cooldown = coroutine.wrap(function ()
    local cup, cdown = 3 * lifemult, 25 * lifemult
    for i = 1, cup do
      bright = i / cup
      coroutine.yield()
    end
    for i = 1, cdown do
      bright = 1 - (i / cdown)
      coroutine.yield()
    end
    efx:Detach()
  end)
  function efx:Tick()
    cooldown()
    rx, ry, rz = rx + dx, ry + dy, rz + dz
    wid = wid + dwid
    dwid = dwid * (1 - ddwid)
  end
end

local function CreateEntity(params)
  local fram = CreateFrame("Frame", shaded)
  
  local dat = {}
  for k, v in pairs(params) do
    dat[k] = v
  end
  
  if not dat.z then dat.z = 0 end
  
  local dss = params.heavy and 240 or 120
  local shift_x = CreateShifter(params.shift_magnitude or 5, params.shift_speed or dss, params.shift_loose)
  local shift_y = CreateShifter(params.shift_magnitude or 5, params.shift_speed or dss, params.shift_loose)
  local shift_z = CreateShifter(params.shift_magnitude or 5, params.shift_speed or dss, params.shift_loose)
  
  local gsmag, gsspeed = 3, 240
  local gridshift_x = CreateShifter(gsmag, gsspeed, true)
  local gridshift_y = CreateShifter(gsmag, gsspeed, true)
  local gridshift_z = CreateShifter(gsmag, gsspeed, true)
  
  local function draw_cube(chunky, grid, gridopac, embedded)
    local hw, hh, hd = chunky.width / 2, chunky.height / 2, chunky.depth / 2
    
    gl.Color(chunky.r, chunky.g, chunky.b, (chunky.a or 1) * (gridopac or 1))
    
    local sx, ex, sy, ey, sz, ez = hw, -hw, hh, -hh, hd, -hd
    
    if not embedded then
      gl.Begin("QUADS")
    else
      sx, ex = sx + chunky.x, ex + chunky.x
      sy, ey = sy + chunky.y, ey + chunky.y
      sz, ez = sz + chunky.z, ez + chunky.z
    end
    
    glutil.VertexAttrib(mega_shader, "size", chunky.width / grid, chunky.height / grid, chunky.depth / grid)
    glutil.VertexAttrib(mega_shader, "fadeable", dat.nofade and 0 or 1)
    
    glutil.VertexAttrib(mega_shader, "coords", 0, 0, 0)
    gl.Vertex(sx, sy, ez)
    glutil.VertexAttrib(mega_shader, "coords", 0, 1, 0)
    gl.Vertex(sx, ey, ez)
    glutil.VertexAttrib(mega_shader, "coords", 1, 1, 0)
    gl.Vertex(ex, ey, ez)
    glutil.VertexAttrib(mega_shader, "coords", 1, 0, 0)
    gl.Vertex(ex, sy, ez)
    glutil.VertexAttrib(mega_shader, "coords", 0, 0, 1)
    gl.Vertex(sx, sy, sz)
    glutil.VertexAttrib(mega_shader, "coords", 0, 1, 1)
    gl.Vertex(sx, ey, sz)
    glutil.VertexAttrib(mega_shader, "coords", 1, 1, 1)
    gl.Vertex(ex, ey, sz)
    glutil.VertexAttrib(mega_shader, "coords", 1, 0, 1)
    gl.Vertex(ex, sy, sz)
    
    glutil.VertexAttrib(mega_shader, "coords", 0, 0, 0)
    gl.Vertex(sx, sy, ez)
    glutil.VertexAttrib(mega_shader, "coords", 1, 0, 0)
    gl.Vertex(ex, sy, ez)
    glutil.VertexAttrib(mega_shader, "coords", 1, 0, 1)
    gl.Vertex(ex, sy, sz)
    glutil.VertexAttrib(mega_shader, "coords", 0, 0, 1)
    gl.Vertex(sx, sy, sz)
    glutil.VertexAttrib(mega_shader, "coords", 0, 1, 0)
    gl.Vertex(sx, ey, ez)
    glutil.VertexAttrib(mega_shader, "coords", 1, 1, 0)
    gl.Vertex(ex, ey, ez)
    glutil.VertexAttrib(mega_shader, "coords", 1, 1, 1)
    gl.Vertex(ex, ey, sz)
    glutil.VertexAttrib(mega_shader, "coords", 0, 1, 1)
    gl.Vertex(sx, ey, sz)
    
    glutil.VertexAttrib(mega_shader, "coords", 0, 0, 0)
    gl.Vertex(sx, sy, ez)
    glutil.VertexAttrib(mega_shader, "coords", 0, 0, 1)
    gl.Vertex(sx, sy, sz)
    glutil.VertexAttrib(mega_shader, "coords", 0, 1, 1)
    gl.Vertex(sx, ey, sz)
    glutil.VertexAttrib(mega_shader, "coords", 0, 1, 0)
    gl.Vertex(sx, ey, ez)
    glutil.VertexAttrib(mega_shader, "coords", 1, 0, 0)
    gl.Vertex(ex, sy, ez)
    glutil.VertexAttrib(mega_shader, "coords", 1, 0, 1)
    gl.Vertex(ex, sy, sz)
    glutil.VertexAttrib(mega_shader, "coords", 1, 1, 1)
    gl.Vertex(ex, ey, sz)
    glutil.VertexAttrib(mega_shader, "coords", 1, 1, 0)
    gl.Vertex(ex, ey, ez)
    
    if not embedded then
      gl.End()
    end
  end
  
  local function doRealRender(self)
    if dat.rotx then
      gl.Rotate(dat.rotx, 0, 1, 0)
    end
    
    glutil.UniformF(mega_shader, "grid", 0.1)
    glutil.UniformF(mega_shader, "grid_offset", gridshift_x:Increment(speed), gridshift_y:Increment(speed), gridshift_z:Increment(speed))
    glutil.UniformF(mega_shader, "bgc", 0.03 + (dat.bgci or 0), 0.03 + (dat.bgci or 0), 0.03 + (dat.bgci or 0), 1.0)
    glutil.UniformF(mega_shader, "fade", fadeamount())
    
    if not dat.geometry then
      draw_cube(dat, dat.gridsize)
    else
      for _, v in ipairs(dat.geometry) do
        gl.Begin("QUADS")
        
        draw_cube(v, dat.gridsize, nil, true)
        
        gl.End()
      end
    end
  end
  
  function fram:Render()
    if dat.pre_render then
      dat:pre_render()
    end
    
    RenderSort(mega_shader, function ()
      local x, y, z = lerp(subframe, dat.x_last, dat.x), lerp(subframe, dat.y_last, dat.y), lerp(subframe, dat.z_last, dat.z)
  
      gl.MatrixMode("MODELVIEW")
      gl.LoadIdentity()
      gl.Translate(x, y, z)
      gl.Rotate(shift_x:Increment(speed), 1, 0, 0)
      gl.Rotate(shift_y:Increment(speed), 0, 1, 0)
      gl.Rotate(shift_z:Increment(speed), 0, 0, 1)
      
      doRealRender(self)
    end)
  end
  function dat:Kill(noshatter)
    if dat.geometry and not noshatter then
      -- we need to shatter shit so uh hmmm
      
      if self.death then
        PlaySound(self.death, 0.5)
      end
      
      if self.deathshake then
        screenshake(self.deathshake)
      end
      
      if self.deathshatter_count then
        for i = 1, self.deathshatter_count do
          local dsmm = 2.0
          CreateShatterEffect(self, "kaboom", 0, dsmm * (math.random() * self.deathshatter_magnitude + self.deathshatter_magnitude / 2), (math.random() * 0.5 + 0.5) * 0.05, 0, 0, 0, 1, math.random(), 0, math.random() * 1.0 + 0.5)
        end
      end
      
      local geodata = {}
      for _, v in ipairs(dat.geometry) do
        --[[local rotspeed = 5
        local dynvel = 0.1
        local blastvel = 0.01]]
        
        local rotspeed = 5
        local dynvel = 0.5
        local blastvel = 0.1
        
        table.insert(geodata, {
          rx = 0,
          ry = 0,
          rz = 0,
          rxd = math.random() * rotspeed,
          ryd = math.random() * rotspeed,
          rzd = math.random() * rotspeed,
          ox = 0,
          oy = 0,
          oz = 0,
          oxd = math.random() * dynvel * 2 - dynvel + math.random() * v.x * blastvel,
          oyd = math.random() * dynvel * 2 - dynvel + math.random() * v.y * blastvel,
          ozd = math.random() * dynvel * 2 - dynvel + math.random() * v.z * blastvel,
        })
      end
      
      local maxlife = 30 * (params.deathtime or 1)
      local tix = 0
      
      fram.Tick = function ()
        dat.x_last, dat.y_last, dat.z_last = dat.x, dat.y, dat.z
        
        tix = tix + speed
        for _, v in ipairs(geodata) do
          v.rx, v.ry, v.rz = v.rx + v.rxd * speed, v.ry + v.ryd * speed, v.rz + v.rzd * speed
          v.ox, v.oy, v.oz = v.ox + v.oxd * speed, v.oy + v.oyd * speed, v.oz + v.ozd * speed
        end
        
        if tix >= maxlife then fram:Detach() end
      end
      
      doRealRender = function (self)
        local bgc_opac = clamp(1 - tix / (maxlife / 2), 0, 1)
        local grid_opac = clamp(1 - (tix - maxlife / 2) / (maxlife / 2), 0, 1)
        glutil.UniformF(mega_shader, "grid", 0.1)
        glutil.UniformF(mega_shader, "grid_offset", gridshift_x:Increment(speed), gridshift_y:Increment(speed), gridshift_z:Increment(speed))
        glutil.UniformF(mega_shader, "bgc", 0.03, 0.03, 0.03, bgc_opac)
        glutil.UniformF(mega_shader, "fade", fadeamount())
        
        for k, v in ipairs(dat.geometry) do
          gl.PushMatrix()
          
          gl.Translate(v.x, v.y, v.z)
          
          gl.Translate(geodata[k].ox, geodata[k].oy, geodata[k].oz)
          gl.Rotate(geodata[k].rx, 1, 0, 0)
          gl.Rotate(geodata[k].ry, 0, 1, 0)
          gl.Rotate(geodata[k].rz, 0, 0, 1)
          
          draw_cube(v, dat.gridsize, grid_opac)
          gl.PopMatrix()
        end
      end
      --fram:Detach()
    else
      fram:Detach()
    end
  end
  function dat:Tick() -- hurfing, also a known quantity of durfing
    dat.x_last, dat.y_last, dat.z_last = dat.x, dat.y, dat.z
  
    dat:tick()
  end
  
  dat:Tick()
  
  tixers[dat] = true
  
  return dat
end

local function collide(one, two)
  return math.abs(two.x - one.x) * 2 <= two.width + one.width and math.abs(two.y - one.y) * 2 <= two.height + one.height
end

local function kill(targ, noshatter)
  dying[targ] = true
  
  if targ.children then
    for _, v in pairs(targ.children) do
      kill(v, noshatter)
    end
  end
  
  targ:Kill(noshatter)
end

local function bullet_chaff(self, useful)
  local r, g, b, dur, dir, flail, size, speed, ct
  if useful then
    r, g, b, dur, dir, flail, size, speed, ct = 0.8, 0.3, 0.3, 15, -1, 0.4, 10, 0.5, 2
  else
    r, g, b, dur, dir, flail, size, speed, ct = 1.0, 1.0, 1.0, 15, 1, 0.2, 4, 1, 1
  end
  
  for i = 1, ct do
    local dx, dy, dz = math.random() * flail * 2 - flail, dir, math.random() * flail * 2 - flail
    local dist = math.sqrt(dx * dx, dy * dy, dz * dz)
    local speed = speed * math.random() + speed
    dx, dy, dz = dx / dist * speed, dy / dist * speed, dz / dist * speed
    
    CreateEntity{
      width = size,
      height = size,
      depth = size,
      x = self.x,
      y = self.y,
      z = self.z,
      gridsize = size,
      shift_magnitude = 90,
      shift_speed = 10,
      shift_loose = true,
      r = r, g = g, b = b, a = 1.0,
      tick = function (self)
        self.x, self.y, self.z = self.x + dx, self.y + dy, self.z + dz
        self.a = self.a - 1.0 / dur
        if self.a < 0 then kill(self) end
      end,
    }
  end
end

local function InitPlayer()
  invincibility_end = overallframe + 120
  return CreateEntity{
    width = 10,
    height = 10,
    x = 0,
    y = ycenter + 300,
    gridsize = 10,
    shift_magnitude = 1,
    player = true,
    deathshatter_count = 12,
    deathshatter_magnitude = 10,
    tick = function (self) end,
    geometry = {
      {
        x = 0, y = 0, z = 0,
        width = 20, height = 20, depth = 4,
        r = 0.25, g = 0.5, b = 0.25,
      },
      {
        x = 0, y = -3, z = 0,
        width = 7, height = 27, depth = 15,
        r = 0.5, g = 1, b = 0.5,
      },
      {
        x = 15, y = -5, z = 0,
        width = 5, height = 15, depth = 5,
        r = 1, g = 1, b = 0.5,
      },
      {
        x = -15, y = -5, z = 0,
        width = 5, height = 15, depth = 5,
        r = 1, g = 1, b = 0.5,
      },
    },
    nofade = true,
    shoot = function (self)
      local width = 3
      local height = 70
      
      local span = 50
      
      local x = math.random() * span + player.x - span / 2
      local y = math.random() * span + player.y - span / 2
      local z = math.random() * span / 2 - span / 4
      playerbullets[CreateEntity{
        width = width,
        height = height,
        depth = width,
        x = x,
        y = y,
        z = z,
        gridsize = 100,
        shift_magnitude = 2,
        shift_speed = 2,
        life = 0,
        tick = function (self)
          self.y = self.y - height
          
          self.life = self.life + 1
          
          if self.y < ycenter - 500 then
            kill(self)
          end
          if self.killnow then
            self:impacted("whatno")
          end
        end,
        impacted = function (self, useful)
          playerbullets[self] = nil -- whee
          if self.life > 1 then kill(self) end
          self.killnow = true
          
          if useful ~= "whatno" then
            bullet_chaff(self, useful)
          end
        end,
        r = 1, g = 1, b = 1,
        nofade = true,
      }] = true
    end,
    grapple = function (self)
      local width = 12
      local height = 12
      playerbullets[CreateEntity{
        width = width,
        height = height,
        depth = width,
        x = player.x,
        y = player.y,
        gridsize = width,
        shift_magnitude = 90,
        shift_speed = 20,
        shift_loose = true,
        grapple = true,
        tick = function (self)
          self.y = self.y - 6
          
          if self.y < ycenter - 500 then
            kill(self)
          end
        end,
        impacted = function (self, useful)
          kill(self)
          
          bullet_chaff(self, useful)
        end,
        r = 1, g = 1, b = 0.5,
        nofade = true,
      }] = true
    end,
  }
end

player = InitPlayer()


local function CreateMonster(params)
  params.tick = function (self)
    if not self.ai_core then
      self.ai_core = coroutine.wrap(function (self)
        self.ai(self)
        while true do coroutine.yield() end
      end, self)
    end
    
    self.ai_core()
    if self.ai_tick then
      self.ai_tick(self)
    end
    if self.ai_grapple_anim then
      self.ai_grapple_anim(self)
    end
    
    if self.y > ycenter + 400 + self.height then
      kill(self, true)
    end
  end
  
  local mon = CreateEntity(params)
  monsters[mon] = true
  
  return mon
end

local last_sound = -1
local function CreateBullet(originator, typ, params)
  if not params then params = {} end
  
  if last_sound ~= ycenter then
    --PlaySound("shot_enemy", 1.0)
    last_sound = ycenter
  end
  
  
  local dx, dy
  
  local tick = function (self)
    self.y = self.y - ycenter_speed
    
    self.x, self.y = self.x + dx * 2 * (params.speed or 1), self.y + dy * 2 * (params.speed or 1)
  end
  
  if typ == "aimed" then
    dx, dy = player.x - originator.x, player.y - originator.y
    local len = math.sqrt(dx * dx + dy * dy)
    dx, dy = dx / len, dy / len
  elseif typ == "directed" then
    dx, dy = math.sin(params.angle), math.cos(params.angle)
  elseif typ == "cubic" then
    local time, ltime = 0, 0
    local dx, dy = 0, 0
    tick = function (self)
      self.y = self.y - ycenter_speed
      
      if time > 1.0 then
        self.x, self.y = self.x + dx, self.y + dy
      else
        ltime = time
        time = time + 1 / params.slowness
        
        local nx, ny, ox, oy = cubic(params[1], params[3], params[5], params[7], time), cubic(params[2], params[4], params[6], params[8], time), cubic(params[1], params[3], params[5], params[7], ltime), cubic(params[2], params[4], params[6], params[8], ltime)
        
        dx, dy = nx - ox, ny - oy
        
        self.x, self.y = self.x + dx, self.y + dy
      end
    end
  else
    assert(false, typ)
  end
  
  local mon = CreateEntity{
    x = originator.x,
    y = originator.y,
    width = 10,
    height = 10,
    depth = 10,
    gridsize = 10,
    shift_magnitude = 90,
    shift_speed = 20,
    shift_loose = true,
    nofade = true,
    r = params.r or 1.0, g = params.g or 0.5, b = params.b or 0.2,
    tick = function (self)
      tick(self)
      
      local xb, yb = (sw + self.width + 100) / 2, (sh + self.height + 100) / 2
      if self.x < -xb or self.x > xb or self.y - ycenter < -yb or self.y - ycenter > yb then
        kill(self)
      end
    end
  }
  
  monsterbullets[mon] = true
end

local function CreateLightMonster(params)
  params.shot = function (self)
    playsounddelay("harm", 0.5, 4)
    self.health = self.health - 1
    if self.health <= 0 then kill(self) end
    return true
  end
  params.grapple = function (self)
    playsounddelay("tink", 0.5, 4)
    return false
  end -- WE CARE NOT FOR YOUR PUNY HUMAN GRAPPLER CANNON
  
  return CreateMonster(params)
end

local grapple_code = nil
local grapple_lockout = false

local function begin_grapple(map, target)
  if tutorial_phase_current == "grapple" then
    tutorial_phase("postgrapple")
  end
  PlaySound("grappled", 0.5)
  
  local grap = CreateFrame("Frame")
  
  local colors = {
    {1, 0, 0},
    {0, 1, 0},
    {0.2, 0.2, 1},
    {1, 1, 0},
  }
  
  local oboundy = CreateFrame("Frame", grap)
  
  local boundy = CreateFrame("Frame", oboundy)
  boundy:SetWidth(#map[1] * 30 + 10)
  boundy:SetHeight(#map * 30 + 10)
  boundy:SetBackgroundColor(0.1, 0.1, 0.1)
  print("BOUNDY!", boundy:GetWidth(), boundy:GetHeight())
  
  --print(U)
  boundy:SetPoint(nil, 0.5, UIParent, nil, 0.5)
  boundy:SetPoint(0.5, nil, UIParent, "TOPLEFT", (UIParent:GetWidth() - sw) / 4, nil)
  
  do
    local sx, sy = target.x + UIParent:GetWidth() / 2, target.y - ycenter + UIParent:GetHeight() / 2
    local gx, gy = boundy:GetXCenter(), boundy:GetYCenter()
    local gxs, gys = boundy:GetWidth(), boundy:GetHeight()
    local tix = 0
    local mtix = 30
    oboundy:SetCoordinateScale(0, 0, boundy:GetWidth())
    oboundy:SetLayer(1000)
    
    function oboundy:Tick()
      tix = tix + 1
      tix = math.min(tix, mtix)
      local prog = tix / mtix
      
      oboundy:SetPoint("CENTER", UIParent, "TOPLEFT", lerp(prog, sx, gx), lerp(prog, sy, gy))
      oboundy:SetWidth(lerp(prog, 0, gxs))
      oboundy:SetHeight(lerp(prog, 0, gys))
    end
    oboundy:Tick()
  end
  
  boundy:SetPoint("CENTER", UIParent, "TOPLEFT")
  
  local function gofs(x, y, xofs, yofs)
    return x * 30 - 20 + (xofs or 0), y * 30 - 20 + (yofs or 0)
  end
  
  local fmatrix = {}
  for y = 1, #map do
    local ro = {}
    for x = 1, #map[y] do
      local fram = CreateFrame("Texture", boundy)
      fram:SetTexture("sigil" .. map[y][x])
      fram:SetColor(unpack(colors[tonumber(map[y][x])]))
      fram:SetWidth(20)
      fram:SetHeight(20)
      fram.cx, fram.cy = gofs(x, y)
      fram.nx, fram.ny = gofs(x, y)
      
      function fram:Tick()
        fram.cx, fram.cy = approach(fram.cx, fram.nx, 1), approach(fram.cy, fram.ny, 1)
        fram:SetPoint("TOPLEFT", boundy, "TOPLEFT", fram.cx, fram.cy)
      end
      fram:Tick()
      
      table.insert(ro, fram)
    end
    table.insert(fmatrix, ro)
  end
  
  local spox = CreateFrame("Frame", boundy)
  spox:SetLayer(-1)
  spox:SetBackgroundColor(0.5, 0.5, 0)
  spox:SetHeight(60)
  spox:SetWidth(30)
  
  local spoxin = CreateFrame("Frame", spox)
  spoxin:SetBackgroundColor(0.1, 0.1, 0.1)
  spoxin:SetPoint("TOPLEFT", spox, "TOPLEFT", 2, 2)
  spoxin:SetPoint("BOTTOMRIGHT", spox, "BOTTOMRIGHT", -2, -2)
  
  spox:SetPoint("TOPLEFT", boundy, "TOPLEFT", 5, 5)
  
  grapple_lockout = true
  
  local spox_x, spox_y = 1, 1
  
  grapple_code = function() -- here is our actual grappley
    speed = math.max(speed - 0.015, speed_slomo)
    
    if WasKeyPressed("x") or respawn then
      grapple_code = function()
        speed = math.min(speed + 0.02, 1.0)
        grapple_lockout = false
      end
      
      if respawn then
        target:grappledone(nil)
      else
        target:grappledone(map)
      end
      grap:Detach()
    end
    
    if WasKeyPressed("arrow_left") then spox_x = spox_x - 1 PlaySound("grappled_move") end
    if WasKeyPressed("arrow_right") then spox_x = spox_x + 1 PlaySound("grappled_move") end
    if WasKeyPressed("arrow_up") then spox_y = spox_y - 1 PlaySound("grappled_move") end
    if WasKeyPressed("arrow_down") then spox_y = spox_y + 1 PlaySound("grappled_move") end
    
    spox_x = clamp(spox_x, 1, #map[1])
    spox_y = clamp(spox_y, 1, #map - 1)
    
    -- do the movin' as necessary
    spox:SetPoint("TOPLEFT", boundy, "TOPLEFT", gofs(spox_x, spox_y, -5, -5))
    
    if WasKeyPressed("z") then
      PlaySound("grappled_shift")
      local a, b = fmatrix[spox_y][spox_x], fmatrix[spox_y + 1][spox_x]
      a.nx, a.ny, b.nx, b.ny = b.nx, b.ny, a.nx, a.ny
      fmatrix[spox_y][spox_x], fmatrix[spox_y + 1][spox_x] = fmatrix[spox_y + 1][spox_x], fmatrix[spox_y][spox_x]
      map[spox_y][spox_x], map[spox_y + 1][spox_x] = map[spox_y + 1][spox_x], map[spox_y][spox_x]
    end
  end
end

local function CreateHeavyMonster(params)
  params.shot = function (self)
    -- we don't really care it turns out
    playsounddelay("tink", 0.5, 4)
    return false
  end
  
  local mapprim = {}
  for k in params.map:gmatch("(%d+)") do
    local ro = {}
    for y in k:gmatch("%d") do
      table.insert(ro, y)
    end
    table.insert(mapprim, ro)
  end
  
  for i = 2, #mapprim do
    assert(#mapprim[i - 1] == #mapprim[i])
  end
  
  local function test_linkages(map)
    local match_count = 0
    for x = 1, #map do
      for y = 1, #map[x] do
        if x <= #map - 2 then
          if map[x][y] == map[x + 1][y] and map[x][y] == map[x + 2][y] then
            -- we got a match
            match_count = match_count + 1
          end
        end
        if y <= #map[x] - 2 then
          if map[x][y] == map[x][y + 1] and map[x][y] == map[x][y + 2] then
            -- we got a match
            match_count = match_count + 1
          end
        end
      end
    end
    return match_count
  end
    
  assert(test_linkages({{"1", "1", "1"}}) == 1)
  assert(test_linkages({{"1"}, {"1"}, {"1"}}) == 1)
  
  local maxlink = test_linkages(mapprim)
  
  local function recreate_layout()
    while true do
      local mapnew = {}
      -- dupe
      for x = 1, #mapprim do
        local ro = {}
        for y = 1, #mapprim[x] do
          table.insert(ro, mapprim[x][y])
        end
        table.insert(mapnew, ro)
      end
      
      -- shooooofle
      for x = 1, #mapprim do
        for y = 1, #mapprim[x] do
          local src = math.random(#mapprim - x + 1) + x - 1  -- urgh 1-aligned arrays
          
          mapprim[x][y], mapprim[src][y] = mapprim[src][y], mapprim[x][y]
        end
      end
      
      for i = 1, #mapnew do
        print(table.concat(mapnew[i]))
      end
      
      if test_linkages(mapnew) == 0 then
        return mapnew
      end
    end
  end
  
  local mon = CreateMonster(params)
  
  function mon:grapple()
    if self.grapplenotify then self:grapplenotify(true) end
    
    local laz = recreate_layout()
    for i = 1, #laz do
      print(table.concat(laz[i]))
    end
    begin_grapple(recreate_layout(), mon)
    return true
  end
  function mon:grappledone(laz)
    self.ai_grapple_anim = coroutine.wrap(function ()
      local dmg = 0
      
      if laz then
        for i = 1, #laz do
          print(table.concat(laz[i]))
        end
        
        dmg = test_linkages(laz)
      end

      for i = 1, dmg do
        PlaySound("grappled_damage")
        
        local delt = 2
        CreateShatterEffect(mon, "slash", math.max(mon.width, mon.height) * 2, 0, 0, math.random() * delt * 2 - delt, math.random() * delt * 2 - delt, math.random() * delt * 2 - delt, 1, 1, 0, 1)

        if i ~= dmg then
          coroutine.pause(10)
        end
      end
      
      if self.grapplenotify then self:grapplenotify(false) end
      
      self.health = self.health - dmg
      if self.health <= 0 then
        kill(self)
      end
      
      self.ai_grapple_anim = nil  -- we is done
    end)
  end
  
  return mon
end

local function CreateGenericMonster(mon)
  if mon.heavy then
    return CreateHeavyMonster(mon)
  else
    return CreateLightMonster(mon)
  end
end


local id = 1
local coro_list = {}




local halt = false
local function death_barrier(ct, text)
  if ct < player_death_count then
    local tex = CreateFrame("Text_Multiline")
    local postfix = ""
    if ct ~= -1 then
      postfix = ("\n\nYou died %d times. In order to get the best ending, try again, but don't die more than %d times."):format(player_death_count, ct)
    end
    tex:SetText(text .. postfix .. "\n\n\n\nPress enter to restart.")
    tex:SetPoint("CENTER", UIParent, "CENTER")
    tex:SetWidth(400)
    tex:SetColor(1, 1, 1)
    tex:ForceHeight()
    halt = true
    accelerate = true
  end
end

local geometrix = {}
local level
do
  local function line_of(params, monster)
    for i = 1, params.quantity do
      monster.x = params.x
      monster.y = ycenter - sh / 2 - monster.height
      monster.ai_tick = params.shoot and params.shoot(i)
      monster.ai = function (self)
        local divert
        if params.flybysound == "small" then
          divert = 100
        elseif params.flybysound == "medium" then
          divert = 250
        elseif params.flybysound == "large" then
          divert = 300
        end
        while true do
          self.y = self.y + (params.speed or 1)
          if not self.sounded and params.flybysound and self.y > player.y - divert then
            playsounddelay("flyby_" .. params.flybysound, 0.5, 1)
            self.sounded = true
          end
          coroutine.yield()
        end
      end
      CreateGenericMonster(monster)
      coroutine.pause(60 * params.span)
    end
  end
  
  local function curve_of(params, monster)
    for i = 1, params.quantity do
      monster.x = 0
      monster.y = ycenter - 1000 -- this is just to get it out of the way, its position will be set in the first ai call
      monster.ai_tick = params.shoot and params.shoot(i)
      monster.ai = function (self)
        local yofs = ycenter
        for i = 1, params.speed do
          self.x, self.y = bezier(params.handles[1], params.handles[3], params.handles[5], params.handles[7], i / params.speed), bezier(params.handles[2], params.handles[4], params.handles[6], params.handles[8], i / params.speed) + ycenter
          coroutine.yield()
        end
        kill(self, true)
      end
      CreateGenericMonster(monster)
      coroutine.pause(60 * params.span)
    end
  end
  
  local function patrol(params, monster)
    monster.x = 0
    monster.y = ycenter - sh / 2 - monster.height
    monster.ai_tick = params.shoot and params.shoot(1)
    local function wait(self, t)
      for i = 1, t do
        self.y = self.y - ycenter_speed
        coroutine.yield()
      end
    end
    local function shift(self, d, t)
      for i = 1, t do
        self.y = self.y - ycenter_speed
        self.x = self.x + d
        coroutine.yield()
      end
    end
    monster.ai = function (self)
      for i = 1, params.drop do
        self.y = self.y + 1
        coroutine.yield()
      end
      
      wait(self, 60)
      
      while true do
        if params.wide == 0 then
          self.y = self.y - ycenter_speed
          coroutine.yield()
        else
          shift(self, 2, 55)
          wait(self, 140)
          shift(self, -2, 110)
          wait(self, 140)
          shift(self, 2, 55)
        end
      end
    end
    CreateGenericMonster(monster)
  end
  
  local function appear(params, monster)
    monster.x = params.x
    monster.y = ycenter + params.y
    monster.ai_tick = params.shoot and params.shoot(1)
    monster.ai = function (self)
      while true do
        self.y = self.y - ycenter_speed
        coroutine.yield()
      end
    end
    CreateGenericMonster(monster)
  end
  
  local function shoot_intermittent(rate, freq, type)
    return function (id)
      local nxt = rate * 60
      return function (self)
        if (id - 1) % freq == 0 then
          nxt = nxt - 1
          
          if nxt == 0 then
            type(self)
            nxt = rate * 60
          end
        end
      end
    end
  end
  local function shoot_burst(on, off, rate, doit)
    return function ()
      local func = function (self)
        while true do
          for i = 1, on do
            if i % rate == 0 then
              doit(self, ct)
            end
            coroutine.yield()
          end
          for i = 1, off do
            coroutine.yield()
          end
        end
      end
      local fcoro
      return function (self)
        if not fcoro then fcoro = coroutine.wrap(func, self) end
        return fcoro()
      end
    end
  end
  
  local function bullet_aimed(self)
    CreateBullet(self, "aimed")
  end
  local function bullet_split(ct, dir, split)
    return function (self)
      local stdr = dir - split * (ct - 1) / 2
      for i = 1, ct do
        CreateBullet(self, "directed", {angle = stdr})
        stdr = stdr + split
      end
    end
  end
  local function bullet_spiral(ct, rotate, speed)
    local nang = 0
    return function (self)
      for i = 1, ct do
        CreateBullet(self, "directed", {angle = nang + (i / ct) * 3.14159 * 2, speed = speed})
      end
      nang = nang + rotate
    end
  end
  
  local blip = {
    width = 40,
    height = 40,
    health = 12,
    gridsize = 15,
    death = "death_blip",
    deathshake = 2,
    deathshatter_count = 2,
    deathshatter_magnitude = 4,
    geometry = {
      {
        x = 0, y = 0, z = 0,
        width = 15, height = 40, depth = 30,
        r = 0.9, g = 0.6, b = 1.0,
      },
      {
        x = 16, y = 0, z = 0,
        width = 10, height = 25, depth = 15,
        r = 0.7, g = 0.45, b = 0.8,
      },
      {
        x = -16, y = 0, z = 0,
        width = 10, height = 25, depth = 15,
        r = 0.7, g = 0.45, b = 0.8,
      },
    }
  }
  geometrix.blip = blip.geometry
  
  local blob = {
    width = 120,
    height = 80,
    gridsize = 20,
    heavy = true,
    health = 1,
    deathtime = 1.5,
    deathshake = 10,
    deathshatter_count = 4,
    deathshatter_magnitude = 8,
    death = "death_blob",
    map = [[
      3111
      2223
      ]],
    geometry = {
      {
        x = 52.5, y = 0, z = 0,
        width = 15, height = 80, depth = 60,
        r = 0.8, g = 0.8, b = 1.0,
      },
      {
        x = -52.5, y = 0, z = 0,
        width = 15, height = 80, depth = 60,
        r = 0.8, g = 0.8, b = 1.0,
      },
      
      {
        x = 32.5, y = 0, z = 0,
        width = 15, height = 60, depth = 40,
        r = 0.5, g = 0.5, b = 1.0,
      },
      {
        x = -32.5, y = 0, z = 0,
        width = 15, height = 60, depth = 40,
        r = 0.5, g = 0.5, b = 1.0,
      },
      
      {
        x = 0, y = 0, z = 0,
        width = 40, height = 40, depth = 20,
        r = 0.2, g = 0.2, b = 1.0,
      },
    }
  }
  geometrix.blob = blob.geometry
  
  local block = {
    width = 140,
    height = 240,
    gridsize = 20,
    heavy = true,
    health = 8,
    deathtime = 2,
    deathshake = 50,
    deathshatter_count = 10,
    deathshatter_magnitude = 16,
    death = "death_boss",
    map = [[
      123
      123
      123
      444]],
    geometry = {
      {
        x = 0, y = 110, z = 0,
        width = 140, height = 20, depth = 80,
        r = 0.8, g = 0.8, b = 0.8,
      },
      {
        x = 0, y = -110, z = 0,
        width = 140, height = 20, depth = 80,
        r = 0.8, g = 0.8, b = 0.8,
      },
      
      {
        x = 60, y = 75, z = 0,
        width = 20, height = 40, depth = 60,
        r = 0.5, g = 0.45, b = 0.425,
      },
      {
        x = 60, y = -75, z = 0,
        width = 20, height = 40, depth = 60,
        r = 0.5, g = 0.45, b = 0.425,
      },
      {
        x = -60, y = 75, z = 0,
        width = 20, height = 40, depth = 60,
        r = 0.5, g = 0.45, b = 0.425,
      },
      {
        x = -60, y = -75, z = 0,
        width = 20, height = 40, depth = 60,
        r = 0.5, g = 0.45, b = 0.425,
      },
      
      {
        x = -30, y = 0, z = 0,
        width = 20, height = 160, depth = 20,
        r = 0.35, g = 0.25, b = 0.20,
      },
      {
        x = 30, y = 0, z = 0,
        width = 20, height = 160, depth = 20,
        r = 0.35, g = 0.25, b = 0.20,
      },
      
      {
        x = 0, y = 70, z = 20,
        width = 60, height = 10, depth = 10,
        r = 0.5, g = 0.25, b = 0.20,
      },
      {
        x = 0, y = 70, z = -20,
        width = 60, height = 10, depth = 10,
        r = 0.5, g = 0.25, b = 0.20,
      },
      {
        x = 0, y = 40, z = 20,
        width = 60, height = 10, depth = 10,
        r = 0.5, g = 0.25, b = 0.20,
      },
      {
        x = 0, y = 40, z = -20,
        width = 60, height = 10, depth = 10,
        r = 0.5, g = 0.25, b = 0.20,
      },
      
      {
        x = 0, y = -70, z = 20,
        width = 60, height = 10, depth = 10,
        r = 0.5, g = 0.25, b = 0.20,
      },
      {
        x = 0, y = -70, z = -20,
        width = 60, height = 10, depth = 10,
        r = 0.5, g = 0.25, b = 0.20,
      },
      {
        x = 0, y = -40, z = 20,
        width = 60, height = 10, depth = 10,
        r = 0.5, g = 0.25, b = 0.20,
      },
      {
        x = 0, y = -40, z = -20,
        width = 60, height = 10, depth = 10,
        r = 0.5, g = 0.25, b = 0.20,
      },
      
      {
        x = 0, y = 0, z = 0,
        width = 40, height = 40, depth = 40,
        r = 0.8, g = 0.1, b = 0,
      }
    }
  }
  geometrix.block = block.geometry
  local function block_ai()
    local grappled = false
    local function func(self)
      local spyral = bullet_spiral(8, -0.04)
      
      while true do
        while not grappled do
          coroutine.yield()
        end
        
        do
          local tim = 0
          while grappled do
            tim = tim + 1
            if tim == 4 then
              spyral(self)
              tim = 0
            end
            coroutine.yield()
          end
        end
        
        coroutine.pause(60)
        
        local widix = 11
        local widtop = 300
        for i = 1, 2 do
          for item = 1, widix do
            if item % 2 == (i - 1) then
              line_of({quantity = 1, span = 0, x = (widtop * 2) / widix * item - widtop}, blip)
            end
          end
          coroutine.pause(30)
        end
      end
      
    end
    
    local fcoro
    return function (self)
      if not fcoro then
        fcoro = coroutine.wrap(func, self)
        function self:grapplenotify(grap)
          grappled = grap
        end
      end
      return fcoro()
    end
  end
  
  local brick = {
    width = 280,
    height = 240,
    gridsize = 20,
    heavy = true,
    health = 20,
    deathtime = 2,
    deathshake = 50,
    deathshatter_count = 18,
    deathshatter_magnitude = 22,
    death = "death_boss",
    r = 0.5, g = 1.0, b = 0.5,
    map = [[
      1222
      1333
      1444
      2221
      3331
      4441
      ]],
    geometry = {
      -- interior core blocks
      {
        x = 10, y = 0, z = 0,
        width = 18, height = 40, depth = 20,
        r = 0.5, g = 1, b = 0.8,
      },
      
      -- top/bottom flanges
      {
        x = 8.5, y = 27, z = 0,
        width = 15, height = 10, depth = 15,
        r = 0.2, g = 1, b = 0.4,
      },
      {
        x = 8.5, y = -27, z = 0,
        width = 15, height = 10, depth = 15,
        r = 0.2, g = 1, b = 0.4,
      },
      
      -- side flanges
      {
        x = 25, y = 20, z = 0,
        width = 10, height = 15, depth = 15,
        r = 0.1, g = 1, b = 0.2,
      },
      {
        x = 25, y = -20, z = 0,
        width = 10, height = 15, depth = 15,
        r = 0.1, g = 1, b = 0.2,
      },
      
      -- poles
      --[[{
        x = 60, y = 0, z = 0,
        width = 80, height = 15, depth = 20,
        r = 0.1, g = 0.5, b = 0.3,
      },]]
      {
        x = 110, y = 0, z = 0,
        width = 15, height = 120, depth = 40,
        r = 0.1, g = 0.5, b = 0.3,
      },
      {
        x = 90, y = -70, z = 0,
        width = 15, height = 50, depth = 80,
        r = 0.1, g = 0.5, b = 0.1,
      },
      {
        x = 70, y = -100, z = 0,
        width = 15, height = 30, depth = 140,
        r = 0.2, g = 0.6, b = 0.2,
      },
      {
        x = 50, y = -120, z = 60,
        width = 15, height = 30, depth = 60,
        r = 0.4, g = 0.7, b = 0.4,
      },
      {
        x = 50, y = -120, z = -60,
        width = 15, height = 30, depth = 60,
        r = 0.4, g = 0.7, b = 0.4,
      },
      {
        x = 32, y = -100, z = 0,
        width = 5, height = 140, depth = 20,
        r = 0.6, g = 0.8, b = 0.6,
      },
      {
        x = 32, y = -100, z = 60,
        width = 5, height = 140, depth = 20,
        r = 0.6, g = 0.8, b = 0.6,
      },
      {
        x = 32, y = -100, z = -60,
        width = 5, height = 140, depth = 20,
        r = 0.6, g = 0.8, b = 0.6,
      },
      
      -- spheres
      {
        x = 120, y = 100, z = 0,
        width = 30, height = 30, depth = 30,
        r = 0.8, g = 0.1, b = 0,
      },
      {
        x = 100, y = 100, z = 0,
        width = 5, height = 20, depth = 20,
        r = 0.4, g = 0.1, b = 0,
      },
      {
        x = 140, y = 100, z = 0,
        width = 5, height = 20, depth = 20,
        r = 0.4, g = 0.1, b = 0,
      },
      {
        x = 120, y = 120, z = 0,
        width = 20, height = 5, depth = 20,
        r = 0.4, g = 0.1, b = 0,
      },
      {
        x = 120, y = 80, z = 0,
        width = 20, height = 5, depth = 20,
        r = 0.4, g = 0.1, b = 0,
      },
      {
        x = 120, y = 100, z = 20,
        width = 20, height = 20, depth = 5,
        r = 0.4, g = 0.1, b = 0,
      },
      {
        x = 120, y = 100, z = -20,
        width = 20, height = 20, depth = 5,
        r = 0.4, g = 0.1, b = 0,
      },
      
      -- handles/front armor
      {
        x = 120, y = 70, z = -30,
        width = 120, height = 5, depth = 30,
        r = 0.25, g = 0.5, b = 0.1,
      },
      {
        x = 120, y = 70, z = 30,
        width = 120, height = 5, depth = 30,
        r = 0.25, g = 0.5, b = 0.1,
      },
      {
        x = 12.5, y = 100, z = 0,
        width = 20, height = 5, depth = 180,
        r = 0.3, g = 0.6, b = 0.1,
      },
      {
        x = 37.5, y = 100, z = 0,
        width = 20, height = 5, depth = 180,
        r = 0.3, g = 0.6, b = 0.1,
      },
      {
        x = 62.5, y = 100, z = 0,
        width = 20, height = 5, depth = 180,
        r = 0.3, g = 0.6, b = 0.1,
      },
      {
        x = 87.5, y = 100, z = 0,
        width = 20, height = 5, depth = 180,
        r = 0.3, g = 0.6, b = 0.1,
      },
      
      -- crosspoles
      {
        x = 45, y = 0, z = 0,
        width = 18, height = 80, depth = 5,
        r = 0.1, g = 0.5, b = 0.0,
      },
      {
        x = 68, y = 0, z = 0,
        width = 18, height = 80, depth = 5,
        r = 0.1, g = 0.5, b = 0.0,
      },
      {
        x = 91, y = 0, z = 0,
        width = 18, height = 80, depth = 5,
        r = 0.1, g = 0.5, b = 0.0,
      },
    },
    pre_render_stage = 0,
    pre_render = function (self)
      if not self.begin_frame then self.begin_frame = overallframe end
      
      local progress = (overallframe - self.begin_frame) * 2
      local kstage = 0
        
      for _, v in pairs(self.geometry) do
        local ab = math.abs(v.orig_x)
        local stagesize = 30
        local stage = math.floor(ab / stagesize + 1) * stagesize
        local ofs = ab - stage
        
        if stage < progress then
          v.x = v.orig_x
          kstage = math.max(kstage, v.x)
        else
          v.x = (stage - progress) * 20 + progress + ofs
          if v.orig_x < 0 then v.x = -v.x end
        end
      end
      
      if self.pre_render_stage ~= kstage then
        PlaySound("mantis_clang", 0.5)
      end
      self.pre_render_stage = kstage
    end
  }
  -- symmetrize
  do
    local geoc = #brick.geometry
    for k = 1, geoc do
      local n = {}
      for k, v in pairs(brick.geometry[k]) do
        n[k] = v
      end
      n.x = -n.x
      table.insert(brick.geometry, n)
    end
    
    -- prepare
    for _, v in pairs(brick.geometry) do
      v.orig_x = v.x
    end
  end
  
  local function brick_ai()
    local grappled = false
    local function func(self)
      local spyrala = bullet_spiral(8, -0.5, 0.5)
      local spyralb = bullet_spiral(8, 0.5, 0.5)
      
      -- let's let them prepare :D
      while not grappled do
        coroutine.yield()
      end
      
      coroutine.pause(240)
      
      while true do
        -- spawn the shooters
        PlaySound("mantis_drone", 0.5)
        self.children = {}
        for i = 1, 6 do
          local tofs = 1
          local tct = 8
          local siz = 60
          local delay = 20
          local health = 30
          local geom
          local heavy = false
          
          if i == 1 or i == 6 then
            tofs = 1.5
            siz = 80
            tct = tct * 2
            delay = delay / 2
            heavy = true
            health = 2
            
            geom = {
              {
                x = 0, y = 0, z = 0,
                width = 15, height = 15, depth = 10,
                r = 1.0, g = 0.20, b = 0.20,
              },
              {
                x = 22.5, y = 0, z = 0,
                width = 15, height = 10, depth = 10,
                r = 0.8, g = 0.8, b = 0.8,
              },
              {
                x = -22.5, y = 0, z = 0,
                width = 15, height = 10, depth = 10,
                r = 0.8, g = 0.8, b = 0.8,
              },
              
              {
                x = 0, y = 22.5, z = 0,
                width = 10, height = 15, depth = 10,
                r = 0.8, g = 0.8, b = 0.8,
              },
              {
                x = 0, y = -22.5, z = 0,
                width = 10, height = 15, depth = 10,
                r = 0.8, g = 0.8, b = 0.8,
              },
              
              {
                x = 37.5, y = 0, z = 0,
                width = 5, height = 60, depth = 15,
                r = 0.5, g = 0.5, b = 0.8,
              },
              {
                x = -37.5, y = 0, z = 0,
                width = 5, height = 60, depth = 15,
                r = 0.5, g = 0.5, b = 0.8,
              },
              {
                x = 0, y = 37.5, z = 0,
                width = 60, height = 5, depth = 15,
                r = 0.5, g = 0.5, b = 0.8,
              },
              {
                x = 0, y = -37.5, z = 0,
                width = 60, height = 5, depth = 15,
                r = 0.5, g = 0.5, b = 0.8,
              },
            }
            
          else
            geom = {
              {
                x = 0, y = 0, z = 0,
                width = 10, height = 10, depth = 10,
                r = 1.0, g = 0.20, b = 0.20,
              },
              {
                x = 20, y = 0, z = 0,
                width = 20, height = 10, depth = 10,
                r = 0.8, g = 0.8, b = 0.8,
              },
              {
                x = -20, y = 0, z = 0,
                width = 20, height = 10, depth = 10,
                r = 0.8, g = 0.8, b = 0.8,
              },
              
              {
                x = 0, y = 20, z = 0,
                width = 10, height = 20, depth = 10,
                r = 0.8, g = 0.8, b = 0.8,
              },
              {
                x = 0, y = -20, z = 0,
                width = 10, height = 20, depth = 10,
                r = 0.8, g = 0.8, b = 0.8,
              },
            }
          end
          
          local mon = {
            x = (sw / 12) * (i * 2 - 1) - sw / 2,
            y = ycenter - 20,
            width = siz,
            height = siz,
            gridsize = 15,
            health = health,
            r = 1, g = 1, b = 1,
            heavy = heavy,
            bgci = 1,
            death = "death_blip",
            deathshake = 2,
            deathshatter_count = 2,
            deathshatter_magnitude = 4,
            map = [[
              2323
              1111
            ]],
            geometry = geom,
            ai_tick = function (self)
              self.y = self.y - ycenter_speed
              self.bgci = math.max(self.bgci - 0.02, 0)
            end,
            ai = function (self)
              coroutine.pause(420)
              
              for ti = 1, tct do
                CreateBullet(self, "directed", {angle = math.random() * tofs - tofs / 2, speed = 2})
                coroutine.pause(delay)
              end
              
              kill(self)
            end
          }
          
          table.insert(self.children, CreateGenericMonster(mon))
        end
        
        coroutine.pause(120)
        
        for i = 1, 6 do
          spyrala({x = self.x + 120, y = self.y + 100})
          spyralb({x = self.x - 120, y = self.y + 100})
          coroutine.pause(30)
        end
        
        coroutine.pause(900)
      end
      
    end
    local function func_two(self)
      while true do
        while not grappled do
          coroutine.yield()
        end
        
        for i = 1, 7 do
          local pdx = player.x - self.x
          local pdy = player.y - self.y
          
          local tdt = (i - 4) * 200
          PlaySound("mantis_launch")
          for k = 0, 3 do
            CreateBullet(self, "cubic", {self.x + tdt, self.y + 2000, self.x, self.y, player.x, player.y, player.x + pdx / 2 + tdt, player.y + pdy, slowness = 180, r = 1 - k * 0.1, g = 1 - k * 0.2, b = 0.5 - k * 0.1})
            coroutine.yield()
          end
          coroutine.pause(4)
        end
        
        while grappled do
          coroutine.yield()
        end
      end
    end
    
    local fcoro1
    local fcoro2
    return function (self)
      if not fcoro1 then
        fcoro1 = coroutine.wrap(func, self)
        fcoro2 = coroutine.wrap(func_two, self)
        function self:grapplenotify(grap)
          grappled = grap
        end
      end
      
      fcoro1()
      fcoro2()
    end
  end
  
  level = {
    {0, tutorial_phase, "basic"},
    {0, line_of, {quantity = 5, span = 0.5, x = -130}, blip},
    {4, line_of, {quantity = 5, span = 0.5, x = 74}, blip},
    {0, tutorial_phase, nil},
    {6, curve_of, {quantity = 6, span = 0.7, speed = 180, handles = {
        -225, -400,
        -225, 200,
        225, -200,
        225, 400,
      }}, blip},
    {10, tutorial_phase, "grapple"},
    {0, patrol, {drop = 120}, blob},
    "halt",
    {0, tutorial_phase, nil},
    {0, death_barrier, 2, "You have defeated the first wave of enemies, but the delay caused by your repeated deaths has permitted your foes to flee. You attempt to catch up, but you never will."},
    
    {0, set_ground_class, 2},
  
    {3, line_of, {quantity = 5, span = 0.5, x = 40, shoot = shoot_intermittent(1, 2, bullet_aimed)}, blip},
    
    {6, line_of, {quantity = 5, span = 0.5, x = -20, shoot = shoot_intermittent(2, 2, bullet_aimed)}, blip},
    {2, line_of, {quantity = 5, span = 0.5, x = 177, shoot = shoot_intermittent(2, 2, bullet_aimed)}, blip},
    {2, line_of, {quantity = 5, span = 0.5, x = -104, shoot = shoot_intermittent(2, 2, bullet_aimed)}, blip},
    
    {10, patrol, {drop = 80, shoot = shoot_intermittent(1, 2, bullet_split(3, 0, 0.3))}, blob},
    
    {10, line_of, {quantity = 1, span = 0.5, x = -200, speed = 0, shoot = shoot_intermittent(2, 1, bullet_split(3, 0, 0.3))}, blob},
    {2, line_of, {quantity = 5, span = 0.5, x = -100}, blip},
    {2, line_of, {quantity = 1, span = 0.5, x = 0, speed = 0, shoot = shoot_intermittent(2, 1, bullet_split(3, 0, 0.3))}, blob},
    {2, line_of, {quantity = 5, span = 0.5, x = 100}, blip},
    {2, line_of, {quantity = 1, span = 0.5, x = 200, speed = 0, shoot = shoot_intermittent(2, 1, bullet_split(3, 0, 0.3))}, blob},
    
    {8, line_of, {quantity = 1, span = 0.5, x = 200, speed = -1, shoot = shoot_burst(180, 180, 30, bullet_spiral(16, -0.1))}, blob},
    {0, line_of, {quantity = 1, span = 0.5, x = -200, speed = -1, shoot = shoot_burst(180, 180, 30, bullet_spiral(16, 0.1))}, blob},
    "halt",
    {0, patrol, {drop = 170, wide = 0, shoot = block_ai}, block},
    "halt",
    {0, death_barrier, 4, "You have defeated the Magma Core, but the delay caused by your repeated deaths has permitted your foes to flee. You attempt to catch up, but you never will."},
    
    {0, set_ground_class, 3},
    
    {6, curve_of, {quantity = 8, span = 0.7, speed = 180, handles = {
      225, -425,
      225, 100,
      -225, 100,
      -225, -425,
    }, shoot = shoot_intermittent(2, 2, bullet_aimed)}, blip},
    {2, line_of, {quantity = 2, span = 4, x = 0, speed = 0, shoot = shoot_intermittent(1, 1, bullet_aimed)}, blob},
    {2, curve_of, {quantity = 8, span = 0.7, speed = 180, handles = {
      -225, -425,
      -225, 100,
      225, 100,
      225, -425,
    }, shoot = shoot_intermittent(2, 2, bullet_aimed)}, blip},
    
    
    {8, curve_of, {quantity = 8, span = 0.7, speed = 180, handles = {
      -400, -300,
      0, -300,
      0, -100,
      400, -100,
    }, shoot = shoot_intermittent(2, 2, bullet_aimed)}, blip},
    {3, curve_of, {quantity = 8, span = 0.7, speed = 180, handles = {
      400, -100,
      0, -100,
      0, 100,
      -400, 100,
    }, shoot = shoot_intermittent(2, 2, bullet_aimed)}, blip},
    {3, curve_of, {quantity = 8, span = 0.7, speed = 180, handles = {
      -400, 100,
      0, 100,
      0, 300,
      400, 300,
    }, shoot = shoot_intermittent(2, 2, bullet_aimed)}, blip},
    
    {3, line_of, {quantity = 1, span = 4, x = -170, speed = 0, shoot = shoot_intermittent(1, 1, bullet_aimed)}, blob},
    {0, line_of, {quantity = 1, span = 4, x = 170, speed = 0, shoot = shoot_intermittent(1, 1, bullet_aimed)}, blob},
    
    {2, line_of, {quantity = 1, span = 4, x = -100, speed = 10, flybysound = "small"}, blip},
    {0.5, line_of, {quantity = 1, span = 4, x = 170, speed = 10, flybysound = "small"}, blip},
    {0.5, line_of, {quantity = 1, span = 4, x = -22, speed = 10, flybysound = "small"}, blip},
    {0.5, line_of, {quantity = 1, span = 4, x = -180, speed = 10, flybysound = "small"}, blip},
    {0.5, line_of, {quantity = 1, span = 4, x = 0, speed = 10, flybysound = "small"}, blip},
    {0.5, line_of, {quantity = 1, span = 4, x = 55, speed = 10, flybysound = "small"}, blip},
    {0.5, line_of, {quantity = 1, span = 4, x = -70, speed = 10, flybysound = "small"}, blip},
    {0.5, line_of, {quantity = 1, span = 4, x = 215, speed = 10, flybysound = "small"}, blip},
    
    {3, curve_of, {quantity = 8, span = 0.7, speed = 180, handles = {
      300, -300,
      0, 0,
      0, 0,
      300, 300,
    }}, blip},
    {3, curve_of, {quantity = 8, span = 0.7, speed = 180, handles = {
      -300, -300,
      0, 0,
      0, 0,
      -300, 300,
    }}, blip},
    
    {3, line_of, {quantity = 1, span = 4, x = 220, speed = 6, flybysound = "medium"}, blob},
    {2, line_of, {quantity = 1, span = 4, x = -117, speed = 6, flybysound = "medium"}, blob},
    
    {5, line_of, {quantity = 1, span = 4, x = 0, speed = 1, flybysound = "large"}, block},
    
    {2, line_of, {quantity = 12, span = 0.4, x = -270, speed = 10, flybysound = "small"}, blip},
    {0, line_of, {quantity = 12, span = 0.4, x = 110, speed = 10, flybysound = "small"}, blip},
    {0, line_of, {quantity = 12, span = 0.4, x = 270, speed = 10, flybysound = "small"}, blip},
    {0, line_of, {quantity = 12, span = 0.4, x = -110, speed = 10, flybysound = "small"}, blip},
    {8, appear, {x = 0, y = -200, shoot = brick_ai}, brick},
    "halt",
    {0, death_barrier, 6, "You have defeated the Mantis Fortress, but the delay caused by your repeated deaths has permitted your foes to flee. You attempt to catch up, but you never will."},
    {0, death_barrier, -1, "You have defeated the Mantis Fortress. The next group of enemies lies far ahead, and you kick the spaceship into hyperdrive to catch them. Someday, they will be defeated."},
  }
end

local backdrop = CreateFrame("Texture", bounds)
backdrop:SetTexture("bg")
backdrop:SetWidth(sw)
backdrop:SetPoint("CENTER", UIParent, "TOPLEFT", 0, -60)

local coordinator = coroutine.wrap(function ()
  grapple_lockout = true
  
  if noplay then
    while true do coroutine.yield() end
  end
  
  -- here's our acceleration routine
  local spoonks = {}
  local function makespoonk(x, y, z, speed, geo, noize, ofs)
    table.insert(spoonks, CreateEntity{
      x = x, y = y, z = z,
      geometry = geo,
      gridsize = 20,
      tick = function (self)
        self.y = self.y - speed
        if not self.sounded and self.y < player.y + ofs then
          playsounddelay("flyby_" .. noize, 0.5, 1)
          self.sounded = true
        end
      end,
    })
  end
  
  makespoonk(20, 600, 30, 12, geometrix.blip, "small", 30)
  makespoonk(-180, 800, 140, 12, geometrix.blip, "small", 30)
  makespoonk(220, 900, -30, 12, geometrix.blip, "small", 30)
  makespoonk(-55, 920, 70, 12, geometrix.blip, "small", 30)
  makespoonk(-100, 1040, -117, 12, geometrix.blip, "small", 30)
  makespoonk(107, 1100, 80, 12, geometrix.blip, "small", 30)
  makespoonk(30, 1220, 90, 12, geometrix.blip, "small", 30)
  makespoonk(100, 1450, 50, 12, geometrix.blip, "small", 30)
  makespoonk(-210, 1660, -70, 12, geometrix.blip, "small", 30)
  makespoonk(140, 1690, 101, 12, geometrix.blip, "small", 30)
  makespoonk(-30, 1820, 150, 12, geometrix.blip, "small", 30)
  makespoonk(-60, 2001, -50, 12, geometrix.blip, "small", 30)
  makespoonk(170, 2400, 50, 12, geometrix.blip, "small", 30)
  
  makespoonk(-65, 2800, 70, 12, geometrix.blob, "medium", 80)
  makespoonk(130, 2900, 50, 12, geometrix.blob, "medium", 80)
  makespoonk(-180, 3300, -90, 12, geometrix.blob, "medium", 80)
  makespoonk(70, 3800, 140, 12, geometrix.blob, "medium", 80)
  
  makespoonk(-200, 4500, -300, 12, geometrix.block, "large", 400)
  
  for i = 1, 120 do
    coroutine.yield()
  end
  
  while ycenter_speed < 1.5 do
    ycenter_speed = ycenter_speed + 0.003
    backdrop:SetPoint("CENTER", UIParent, "TOPLEFT", 0, -60 - ycenter * 8)
    coroutine.yield()
  end
  
  for _, v in pairs(spoonks) do
    kill(v, true)
  end
  
  grapple_lockout = false
  
  -- start the level itself
  for _, inst in ipairs(level) do
    if halt then break end
    
    if type(inst) == "table" then
      inst[1] = inst[1] * 60
      for i = 1, inst[1] do
        coroutine.yield()
      end
      
      local ind = id
      id = id + 1
      coro_list[ind] = coroutine.wrap(function ()
        inst[2](inst[3], inst[4])
        coro_list[ind] = false
      end)
      coro_list[ind]()
    elseif inst == "halt" then
      while next(monsters) do
        coroutine.yield()
      end
    else
      assert(false, inst)
    end
  end
  
  while(true) do
    coroutine.yield()
  end
end)



local grapl_cooldown = 0
local inertia_dx, inertia_dy = 0, 0
local accel = 0

function tick_loop(...)
  if grapple_code then grapple_code() end
  if halt and (IsKeyDownFrame("enter") or IsKeyDownFrame("return")) then
    GlorpController("exit_game")
  end
  
  subframe = subframe + speed
  overallframe = overallframe + speed
  ycenter = ycenter - ycenter_speed * speed
  screenshake_time(speed)
  
  for k, v in pairs(dels) do
    dels[k] = v - 1
  end
  
  while subframe > 1 do
    coordinator()
    
    for _, v in pairs(coro_list) do
      if type(v) == "function" then
        v()
      end
    end
    
    for k in pairs(tixers) do
      k:Tick()
    end
    
    if respawn and respawn < overallframe then
      player = InitPlayer()
      respawn = nil
    end
    
    local movespeed = 3
    
    if not respawn and not accelerate then
      if not grapple_lockout then
        inertia_dx, inertia_dy = 0, 0
        player.rotx = 0
        if IsKeyDownFrame("arrow_left") then inertia_dx = inertia_dx - movespeed player.rotx = -10 end
        if IsKeyDownFrame("arrow_right") then inertia_dx = inertia_dx + movespeed player.rotx = 10 end
        if IsKeyDownFrame("arrow_up") then inertia_dy = inertia_dy - movespeed end
        if IsKeyDownFrame("arrow_down") then inertia_dy = inertia_dy + movespeed end
      else
        inertia_dx, inertia_dy = approach(inertia_dx, 0, 0.1), approach(inertia_dy, 0, 0.1)
      end
      
      local mult = 1.0
      if not grapple_lockout then mult = 1 / speed end
      
      player.x = player.x + inertia_dx * mult
      player.y = player.y + inertia_dy * mult - ycenter_speed
    
      local xb = (sw - player.width) / 2
      local yb = (sh - player.height) / 2
      
      player.x = clamp(player.x, -xb, xb)
      player.y = clamp(player.y, -yb + ycenter, yb + ycenter)
    
      if not grapple_lockout then
        if IsKeyDownFrame("z") then
          player:shoot()
          playsounddelay("shot", 0.2, 3)
        end
        if WasKeyPressed("x") then
          if grapl_cooldown <= 0 then
            PlaySound("grapple", 0.5)
            grapl_cooldown = 120
            player:grapple()
          end
        end
      end
    end
    
    if accelerate then
      player.y = player.y - accel
      accel = accel + 1
    end
    
    grapl_cooldown = grapl_cooldown - 1
    
    for bullet in pairs(playerbullets) do
      for mon in pairs(monsters) do
        if collide(bullet, mon) then
          if bullet.grapple then
            bullet:impacted(mon:grapple())
          else
            bullet:impacted(mon:shot())
          end
        end
      end
    end
    
    local death = false
    
    for mon in pairs(monsters) do
      if collide(player, mon) then
        death = true
      end
    end
    
    for mon in pairs(monsterbullets) do
      if collide(player, mon) then
        death = true
      end
    end
    
    if death and invincibility_end < overallframe and not respawn and not accelerate then
      player_death_count = player_death_count + 1
      kill(player)
      PlaySound("death_player", 0.5)
      respawn = overallframe + 120
    end
    
    for k in pairs(dying) do
      playerbullets[k] = nil
      monsters[k] = nil
      monsterbullets[k] = nil
      tixers[k] = nil
    end
    dying = {}
    
    subframe = subframe - 1
  end
  
  if speed == 1.0 then -- we'll just get ourselves up to date slowly
    local diff = math.min(1.0 - subframe, 0.1)
    ycenter = ycenter - ycenter_speed * diff
    subframe = subframe + 0.1
  end
  
  bounds:SetCoordinateScale(screenshake_gx(), ycenter + screenshake_gy(), sw) -- setting coords here
end


-- we got all our bloom code here and further down

local function nextpow2(x)
  local nx = 16
  while nx < x do
    nx = nx * 2
  end
  return nx
end

-- init here: make two temp texes for this entire thing that can be rendered onto
local function MakeFBO(width, height, depth, power2, internal, bgrmode)
  print("started at", width, height)
  --[[if power2 then
    width, height = nextpow2(width), nextpow2(height)
  end]]
  print("ended at", width, height)
  
  local tex = glutil.Texture()
  local fbo = glutil.Framebuffer()
  gl.Enable("TEXTURE_2D")
  glutil.BindTexture("TEXTURE_2D", tex)
  gl.TexParameter("TEXTURE_2D", "TEXTURE_MIN_FILTER", "LINEAR")
  gl.TexParameter("TEXTURE_2D", "TEXTURE_MAG_FILTER", "LINEAR")
  gl.TexImage2D("TEXTURE_2D", 0, 4, width, height, 0, "RGBA", "UNSIGNED_BYTE")
  
  glutil.BindTexture("TEXTURE_2D", nil)
  
  glutil.BindFramebuffer("FRAMEBUFFER", fbo)
  glutil.FramebufferTexture2D("FRAMEBUFFER", "COLOR_ATTACHMENT0", "TEXTURE_2D", tex, 0)
  if depth then
    local depth = glutil.Renderbuffer()
    glutil.BindRenderbuffer("RENDERBUFFER", depth)
    gl.RenderbufferStorage("RENDERBUFFER", "DEPTH_COMPONENT16", width, height)
    glutil.BindRenderbuffer("RENDERBUFFER", nil)
    glutil.FramebufferRenderbuffer("FRAMEBUFFER", "DEPTH_ATTACHMENT", "RENDERBUFFER", depth)
  end
  assert(gl.CheckFramebufferStatus("FRAMEBUFFER") == "FRAMEBUFFER_COMPLETE", gl.CheckFramebufferStatus("FRAMEBUFFER"))
  glutil.BindFramebuffer("FRAMEBUFFER", nil)
  gl.Disable("TEXTURE_2D")
  
  return fbo, tex
end

local t_base, t_base_t = MakeFBO(sw * multisample, sh * multisample, true)
local multidown = {}
for i = 1, multisample_pass do
  table.insert(multidown, {MakeFBO(sw * multisample / math.pow(2, i), sh * multisample / math.pow(2, i))})
end
local t_s1, t_s1_t = MakeFBO(sw / 2, sh / 2)
local t_s2, t_s2_t = MakeFBO(sw / 4, sh / 4)
local t_blur1, t_blur1_t = MakeFBO(sw / 4, sh / 4)

local tex = glutil.Texture()

local targ = CreateFrame("Frame")
targ:SetLayer(-1)
function targ:Render()
  -- set to target thing
  -- set the coordinates?
  
  -- setup projection matrices
  gl.MatrixMode("TEXTURE")
  gl.LoadIdentity()
  gl.MatrixMode("MODELVIEW")
  gl.LoadIdentity()
  gl.MatrixMode("PROJECTION")
  
  -- do our actual render
  glutil.BindFramebuffer("FRAMEBUFFER", t_base)
  gl.ClearColor(0.2, 0.2, 0.2, 1)
  gl.Clear("COLOR_BUFFER_BIT,DEPTH_BUFFER_BIT")
  gl.ClearColor(0, 0, 0, 0)
  shmup:Render()
  
  -- do some setup
  gl.Enable("TEXTURE_2D")
  gl.MatrixMode("TEXTURE")
  gl.LoadIdentity()
  gl.MatrixMode("PROJECTION")
  gl.Color(1, 1, 1)
  
  -- multisample passes
  for i = 1, multisample_pass do
    glutil.BindTexture("TEXTURE_2D", multidown[i - 1] and multidown[i - 1][2] or t_base_t)
    glutil.BindFramebuffer("FRAMEBUFFER", multidown[i][1])
    gl.LoadIdentity()
    gl.Ortho(0, sw / 2, sh / 2, 0, -1, 1)
    gl.Viewport(0, 0, sw * multisample / math.pow(2, i), sh * multisample / math.pow(2, i))
    gl.TexParameter("TEXTURE_2D", "TEXTURE_WRAP_S", "CLAMP")
    gl.TexParameter("TEXTURE_2D", "TEXTURE_WRAP_T", "CLAMP")
    glutil.RenderArray("TRIANGLE_FAN", 2, {0, 0, sw / 2, 0, sw / 2, sh / 2, 0, sh / 2}, nil, nil, 2, {0, 1, 1, 1, 1, 0, 0, 0})
  end
  
  -- first pass: rescale first
  glutil.BindTexture("TEXTURE_2D", multidown[#multidown][2])
  glutil.BindFramebuffer("FRAMEBUFFER", t_s1)
  gl.LoadIdentity()
  gl.Ortho(0, sw / 2, sh / 2, 0, -1, 1)
  gl.Viewport(0, 0, sw / 2, sh / 2)
  gl.TexParameter("TEXTURE_2D", "TEXTURE_WRAP_S", "CLAMP")
  gl.TexParameter("TEXTURE_2D", "TEXTURE_WRAP_T", "CLAMP")
  glutil.RenderArray("TRIANGLE_FAN", 2, {0, 0, sw / 2, 0, sw / 2, sh / 2, 0, sh / 2}, nil, nil, 2, {0, 0, 1, 0, 1, 1, 0, 1})
  
  -- second pass: rescale second
  glutil.BindTexture("TEXTURE_2D", t_s1_t)
  glutil.BindFramebuffer("FRAMEBUFFER", t_s2)
  gl.LoadIdentity()
  gl.Ortho(0, sw / 4, sh / 4, 0, -1, 1)
  gl.Viewport(0, 0, sw / 4, sh / 4)
  gl.TexParameter("TEXTURE_2D", "TEXTURE_WRAP_S", "CLAMP")
  gl.TexParameter("TEXTURE_2D", "TEXTURE_WRAP_T", "CLAMP")
  glutil.RenderArray("TRIANGLE_FAN", 2, {0, 0, sw / 4, 0, sw / 4, sh / 4, 0, sh / 4}, nil, nil, 2, {0, 0, 1, 0, 1, 1, 0, 1})
  
  -- set up our shader
  glutil.UseProgram(blurry_shit)
  glutil.UniformI(blurry_shit, "source", 0)
  
  -- third pass: blur one axis
  glutil.BindTexture("TEXTURE_2D", t_s2_t)
  glutil.BindFramebuffer("FRAMEBUFFER", t_blur1)
  for i = 1, 5 do
    glutil.UniformF(blurry_shit, "offsets[" .. (i - 1) .. "]", 4/sw * (i - 3), 0)
    --glutil.UniformF(blurry_shit, "offsets[" .. (i - 1) .. "]", 0, 0)
  end
  gl.TexParameter("TEXTURE_2D", "TEXTURE_WRAP_S", "CLAMP")
  gl.TexParameter("TEXTURE_2D", "TEXTURE_WRAP_T", "CLAMP")
  glutil.RenderArray("TRIANGLE_FAN", 2, {0, 0, sw / 4, 0, sw / 4, sh / 4, 0, sh / 4}, nil, nil, 2, {0, 0, 1, 0, 1, 1, 0, 1})
  
  -- fourth pass: blur other axis
  glutil.BindTexture("TEXTURE_2D", t_blur1_t)
  glutil.BindFramebuffer("FRAMEBUFFER", nil)
  gl.LoadIdentity()
  gl.Ortho(0, 1024, 768, 0, -1, 1)
  gl.Viewport(0, 0, 1024, 768)
  for i = 1, 5 do
    glutil.UniformF(blurry_shit, "offsets[" .. (i - 1) .. "]", 0, 4/sh * (i - 3))
    --glutil.UniformF(blurry_shit, "offsets[" .. (i - 1) .. "]", 0, 0)
  end
  local sx, sy, ex, ey = (1024-sw) / 2, 0, (1024+sw) / 2, sh
  gl.TexParameter("TEXTURE_2D", "TEXTURE_WRAP_S", "CLAMP")
  gl.TexParameter("TEXTURE_2D", "TEXTURE_WRAP_T", "CLAMP")
  glutil.RenderArray("TRIANGLE_FAN", 2, {sx, sy, ex, sy, ex, ey, sx, ey}, nil, nil, 2, {0, 0, 1, 0, 1, 1, 0, 1})
  
  -- now render the original on top, additively (yes yes this is right, trust me)
  glutil.UseProgram()
  
  gl.BlendFunc("ONE", "ONE")
  glutil.BindTexture("TEXTURE_2D", multidown[#multidown][2])
  local sx, sy, ex, ey = (1024-sw) / 2, 0, (1024+sw) / 2, sh
  glutil.RenderArray("TRIANGLE_FAN", 2, {sx, sy, ex, sy, ex, ey, sx, ey}, nil, nil, 2, {0, 1, 1, 1, 1, 0, 0, 0})
  
  gl.BlendFunc("SRC_ALPHA", "ONE_MINUS_SRC_ALPHA")
  glutil.BindTexture("TEXTURE_2D", nil)
  gl.Disable("TEXTURE_2D")
end

function intro_overlay()
  print("overlay start")
  local mv = {
    width = 0, height = 0,
    x = 0, y = -100, z = 40,
    gridsize = 20,
    geometry = {},
    shift_speed = 1200,
    tick = function () end,
  }
  local introfont =
[[
|   #  -----   ---
|  #  |     | |   |
| #   |   * | |   |
|     |  *  |  -- |
| #   | *   |     | 
|  #  |     |   # |
|   #  -----   #  | #
]]
  local lin = {}
  local mls = 0
  for k in introfont:gmatch("([^%s\n][^\n]*[^%s\n])") do
    local ro = {}
    for m in k:gmatch("(.)") do
      table.insert(ro, m)
    end
    mls = math.max(mls, #ro)
    table.insert(lin, ro)
  end
  
  for _, v in pairs(lin) do
    while #v < mls do
      table.insert(v, " ")
    end
  end
  
  local xofs = -mls * 20 / 2
  local yofs = -#lin * 20 / 2
  
  for y, row in ipairs(lin) do
    for x, col in ipairs(row) do
      if col ~= " " then
        local sx, sy = x, y
        local ex, ey = x, y
        local dx, dy
        
        local r, g, b = 0.6, 0.6, 0.6
        if col == "#" then
          dx, dy = 0, 0
        elseif col == "*" then
          dx, dy = 0, 0
          r, g, b = 1.0, 0.6, 0.6
        elseif col == "|" then
          dx, dy = 0, 1
        elseif col == "-" then
          dx, dy = 1, 0
        end
        
        lin[y][x] = " "
        
        while lin[ey + dy] and lin[ey + dy][ex + dx] == col do
          ex, ey = ex + dx, ey + dy
          lin[ey][ex] = " "
        end
        
        local mx, my = (sx + ex) / 2, (sy + ey) / 2
        
        table.insert(mv.geometry, {
          x = xofs + mx * 20, y = yofs + my * 20, z = 0,
          width = (ex - sx + 1) * 20, height = (ey - sy + 1) * 20, depth = 20,
          r = r, g = g, b = b,
        })
      end
    end
  end

  CreateEntity(mv)
end
